/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CFRACTION_H
#define CFRACTION_H

#include<qstring.h>


/** The CFraction class provides basic operations on fractions. */

class CFraction {
private:
  void sign();
  void abridge();

public:
  int numerator;
  int denominator;
  
  /** Creates a fraction with numerator equal to 0 and
      denominator equal to 1. */
  CFraction(){ numerator = 0; denominator = 1; }
  
  /** Creates a fraction with numerator equal to \a n and
      denominator equal to \a d (default 1). */
  CFraction(int n, int d = 1){ numerator = n; denominator = d; }
  
  /** Destroys the fraction.  */
  ~CFraction(){}
  
  CFraction operator+(const CFraction &x);
  CFraction operator-(const CFraction &x);
  CFraction operator*(const CFraction &x);
  CFraction operator/(const CFraction &x);

  QString text();

};

#endif



  
