/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CMATRIX_H
#define CMATRIX_H

#include "cfraction.h"

/** The CMatrix class provides basic operations on matrices
    with CFraction elements. */

class CMatrix {
private:
  int rows;
  int cols;
  int* emptyRow;
  int* emptyCol;
  int* colIndex;
  
  void checkRows();
  void checkColumns();
  void swapRows(int row1, int row2);
  void swapColumns(int col1, int col2);
  void divide(int row, CFraction frac);
  void multiply(int row, CFraction frac);
  void subtract(int row1, int row2, CFraction frac);
  void extend();
  int order();
  
public:
  CFraction** data;

  CMatrix(int numRows, int numCols);
  CMatrix(CMatrix &source);
  ~CMatrix();
  
  CMatrix & operator=(CMatrix &source);
  CMatrix & operator*(const CMatrix &m);
  
  QString text();
  
  /** Returns the number of rows. */
  int rowsCount() const { return rows; }
  
  /** Returns the number of columns. */
  int colsCount() const { return cols; }
  
  void solve();
  QString invariants();
};  

#endif

