/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COPTIONS_H
#define COPTIONS_H

#include <qstring.h> 

class COptions { 
public:
	// Editor
  int  placeWidth;
  int  placeHeight;
  int  transitionWidth;
  int  transitionHeight;
  int  lineWidth;
  int  arrowheadWidth;
  int  arrowheadHeight;

	// Simulator
	bool ignoreTime;
	bool ignorePriorities;
	
	// Reachability graphs
	bool graphIgnoreTime;
	bool graphIgnorePriorities;
	bool limitGraphSize;
	int  graphSizeLimit;
	
	// Xfig Export
	int  xfigSize;
	int  xfigOrientation;
	int  xfigLineWidth;
	bool xfigFillShapes;	
	
	// SVG Export
	int svgCanvasWidth;
	int svgCanvasHeight;
	int svgX;
	int svgY;
	int svgViewWidth;
	int svgViewHeight;
	QString svgStylesheet;
	QString svgScript;
	QString svgScriptType;
	
	QString settingsPath;
	
	/** Creates the object. */
	COptions(){}
	
	/** Destroys the object. */
	~COptions(){}
	
};







#endif
