/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CTABLEITEM_H
#define CTABLEITEM_H

#include <qtable.h>
#include <qlineedit.h>

/** The class represents items of a \a QTable. */

class CTableItem : public QTableItem
{
public:
  /** Creates a table item that is a child of \a table with no text. */
  CTableItem(QTable *table) : QTableItem(table, OnTyping)
  {}

  /** Creates a table item that is a child of \a table with \a text. */
  CTableItem(QTable *table, const QString & text)
    : QTableItem(table, OnTyping, text){}

  /** Sets the alignment to the left for any item contents. */
  int alignment() const { return AlignLeft | AlignVCenter; }
};

#endif
