/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CNODE_H
#define CNODE_H

#include <qstring.h>

/** The CNode class is the base class of all place and transition objects. */

class CNode
{
protected:
  int     nodeTag;       // node identifier
  QString nodeName;

public:
  /** Constructs a CNode object with the \a tag and \a name. */
  CNode(int tag, QString name) : nodeTag(tag),  nodeName(name){}

  /** Destroys the CNode.  */
  ~CNode(){}

  /** Returns the tag of the element. */
  int tag() const { return nodeTag; }
  
  /** Sets the tag of the element. */
  void setTag(int tag){ nodeTag = tag; }

  /** Returns the name of the element. */
  QString name() const { return nodeName; }

  /** Sets the element name to \a name. */
  void setName(QString name) { nodeName = name; }

};

#endif

