/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cplace.h"

//--------------------------------------------------------------------------
/**
  Sets the place marking to \a m.
  If \a m < 0, the place marking = 0 is set.
  If \a m > the place capacity, the place marking = the place capacity is set.
*/

void CPlace::setMarking(int m)
{
  if(placeCapacity == 0) // infinite capacity
    currentMarking = m;
  else
  {
    if(m > placeCapacity)
      currentMarking = placeCapacity;
    else
      if(m < 0)
        currentMarking = 0;
      else
        currentMarking = m;
  }
}

//--------------------------------------------------------------------------
/**
  Sets the place initial marking to \a m.
  If \a m < 0, the place initial marking = 0 is set.
  If \a m > the place capacity, the place initial marking =
  the place capacity is set.
*/

void CPlace::setInitialMarking(int m)
{
  if(placeCapacity == 0) // infinite capacity
    initMarking = m;
  else
  {
    if(m > placeCapacity)
      initMarking = placeCapacity;
    else
      if(m < 0)
        initMarking = 0;
      else
        initMarking = m;
  }
}


