/***************************************************************************
    copyright  : (C) 2004 - 2005 by Marcin Szpyrka
    email      : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CXFIGEXPORT_H
#define CXFIGEXPORT_H

#include <qstring.h>
#include <qfile.h>
#include <qcanvas.h>

#include "../view/cellipsewithlabels.h"
#include "../view/crectanglewithlabels.h"
#include "../view/clinewithlabels.h"
#include "../model/carc.h"

/** 
  The CXfigExport class provides a generator to write output xfig files.
*/

class CXfigExport
{
private:
	static const int scale;
	static const int fsize;

	QFile&file;
	QTextStream*stream;
	int width;
	int orientation;
	int papersize;
	int fill;
	
	void writeLabel(QString, int, int);
	void writeRectangle(int, int, int, int);
	void writeDot(int, int);
	void writeEllipseWithLabels(CEllipseWithLabels*);
	void writeRectangleWithLabels(CRectangleWithLabels*);
	void writeLineWithLabels(CLineWithLabels*);

public:
	CXfigExport(QFile&, int = 1, int = Portrait, int = Letter, bool = false);
	
	enum {Landscape, Portrait, Letter, Legal, Ledger, Tabloid,
		A, B, C, D, E, A4, A3, A2, A1, A0, B5};
	
	void exportNet(QCanvas*);
};

#endif
