/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CXMLGENERATOR_H
#define CXMLGENERATOR_H

#include <qstring.h>
#include <qstringlist.h> 
#include <qtextstream.h>
#include <qtextcodec.h>
#include "../model/cnet.h"
#include <qcanvas.h>
#include "../view/cnetview.h"

/** 
  The CXMLGenerator class provides a generator to write output XML files.
*/

class CXMLGenerator
{
private:
	QTextStream output;
	int indentSize;
	int level;
	
	QString escapeXML(const QString &text);

public:
	CXMLGenerator(QIODevice *device, int indent = 2, QTextCodec *codec = 0);
	
	/** Destroys the xml generator. */
	~CXMLGenerator(){}

	void writeOpenTag(const QString& name, const QStringList& attrList);
	void writeOpenTag(const QString& name);
  void writeCloseTag(const QString& name);
	void writeTag(const QString& name, const QStringList& attrList, 
								const QString& text, bool newLine);
	void writeTag(const QString& name, const QString& text, bool newLine);
	void writeOpenCloseTag(const QString& name, const QStringList& attrList);
	void writeNet(CNetView* netView);
	
};

#endif
