/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CXMLREADER_H
#define CXMLREADER_H

#include <qxml.h>
#include <qcanvas.h>
#include "../model/cnet.h"
#include "../view/cnetview.h"
#include "../view/clinewithlabels.h"


/**
 The CXMLReader class provides an interface for reading xml files
 with APE net models.
*/

class CXMLReader : public QXmlDefaultHandler
{
private:
	CNet*	    net;
  QCanvas*  netCanvas;
  CNetView* netView;
  CLineWithLabels *currLine;
  
  int placeID;	
  int transID;
  
  // node sizes
	int	plWidth; 
	int	plHeight; 
	int	trWidth;
	int	trHeight;	
	int linWidth;
	int	ahWidth;
	int ahHeight;
	
public:
  CXMLReader(CNet* n, CNetView* nv);

  bool startElement(const QString &namespaceURI, const QString &localName,
                    const QString &qName, const QXmlAttributes &attribs);
		
  bool endElement(const QString &namespaceURI, const QString &localName,
                  const QString &qName); 
	
	bool characters(const QString &str);
		
  bool fatalError(const QXmlParseException &exception);
};


#endif
