#ifndef _IXML_TAG_STREAM
#define _IXML_TAG_STREAM

#include "XMLTag.h"

namespace SVGOutput
{

/**
 This class defines abstract interface for
 retrieving XML data from arbitrary objects.
*/

class IXMLTagStream
{
public:
	/** Initializes stream. */
	virtual void init() = 0;

	/** Resets stream. */
	virtual void reset() = 0;
	
	/** Retrieves next element in the stream. */
	virtual XMLTag *next() = 0;

	/** Test whether there are any elements left to read. */
	virtual bool hasNext() = 0;
	
	/** Virtual destructor */
	virtual ~IXMLTagStream() { }
};

} // end of namespace SVGOutput

#endif // _IXML_TAG_STREAM
