/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CELEMENT_H
#define CELEMENT_H

/** 
  The CElement class provides a base class for graphical classes.
*/

class CElement
{
protected:
  int   elemTag;
  void* modelPtr;

public:
  /** Constructs an element. */
  CElement(int etag = 0){ elemTag = etag; }

  /** Destroys the element. */
  ~CElement(){}

  /** Returns the tag of the element. */
  int tag() const { return elemTag; }

  /** Sets the element tag to \a etag. */
  void setTag(int etag){ elemTag = etag; }

  /** Returns a pointer to the logical model of the element. */
  void* modelPointer() const { return modelPtr; }

  /** Sets the the logical model pointer to \a mp. */
  void setModelPointer(void* mp){ modelPtr = mp; }

};

#endif
