/***************************************************************************
    copyright            : (C) 2004 - 2005 by Marcin Szpyrka
    email                : mszpyrka@agh.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CSEGMENT_H
#define CSEGMENT_H

#include <qcanvas.h>

/** The CSegment class provides a segment of a polyline.
	The class inherits methods from QCanvasLine.
*/

class CSegment : public QCanvasLine {
protected:
	int sTag;
	void* polyPointer;
public:
	enum { RTTI = 10013 };
	
	/** Creates a segment on \a canvas. */
	CSegment(int stag, QCanvas * canvas, void* p) : QCanvasLine(canvas)
	{ sTag = stag; 
		polyPointer = p; }
	
	/** Destroys the segment. */
	~CSegment(){ hide(); }
	
	/** Returns CLine class RTTI */
	virtual int rtti() const { return RTTI; }
	
	/** Returns a pointer to the polyline. */
	void* owner() const { return polyPointer; }
	
	/** Sets the polyline pointer to \a p. */
	void setOwner(void* p){ polyPointer = p; }
	
	void setSelected(bool yes);
	
	/** Returns the tag of the segment. */
	int tag() const { return sTag; }
	
	/** Sets the segment tag to \a stag. */
	void setTag(int stag){ sTag = stag; }
};


#endif
